# Programmation Avancée

>  Réalisation d’un correcteur orthographique

## Description du programme

Pour notre programme, nous avons fortement réfléchi à la structure à utiliser en prenant en compte la vitesse d’exécution du programme et la mémoire utilisée. Nous utilisons dans un premier temps un tableau d'arbre, chaque case du tableau comprend une lettre et un pointeur donnant l’accès a l’ensemble des mot commençant par cette lettre. Nous avons donc décidé de faire une structure comprenant un arbre par case du tableau avec n branche. Les branches de l'arbre sont représentées par une liste chaînée. Voici une image plus explicite de notre structure : 
![](img/tableau.PNG)
![](img/structure.PNG)

## Mode d'emploi

Lors du lancement du programme nous devons rajouter en paramètre deux fichiers textes, le premier étant le dictionnaire (words.txt) et le second un fichier texte (texte.txt) quelconque comportant un texte donc nous voulons relever les fautes. Une fois lancé, le programme va charger le dictionnaire et ensuite donner les mots du texte qui ne sont pas présent dans le dictionnaire. Suite à cela nous avons la possibilité de tester un mot ou une phrase. A cette étape du programme nous pouvons rentrer ‘0’ pour quitter. 


## Conditions importantes 

Les fichiers entrés en paramètre doivent être en UTF-8, sinon le programme bloque sur certain caractère spéciaux.